package VoiceCommand;
import java.io.*;
import java.net.URL;

public class RunCommand {

	
		   public static String execParam(String voiceString)
		  {
		      try{
		    // Open the file that is the first 
		    // command line parameter
		   
		    URL name = RunCommand.class.getResource("VoiceCommand.command");
		    String myname = name.toString();
		    myname = myname.substring(6);
		    //System.getProperty("os.name").toLowerCase().contains("win");
		  //  if (System.getProperty("os.name").contains("Windows")){
		    String osType = System.getProperty("os.name").toLowerCase();
		    if (osType.contains("windows")){
		    	myname = myname.replaceAll("/","//");
		    	myname = myname.replaceAll("%20"," ");
		    } else {
		    	/*Nanti kena test kat linux
		    	 * 
		    	 * 
		    	 */
		    	
		    }

		   // System.out.println("xxx: " + name);
		    //System.out.println("yyyy: " + myname);
		   
		    
		    FileInputStream fstream = new FileInputStream(myname);
		    // Get the object of DataInputStream
		    DataInputStream in = new DataInputStream(fstream);
		    BufferedReader br = new BufferedReader(new InputStreamReader(in));
		    String strLine;
		    //Read File Line By Line
		    while ((strLine = br.readLine()) != null)   {
		      // Print the content on the console
		    	//System.out.println (strLine); // For testing
		    	if(strLine.contains(voiceString) && strLine.contains(osType) ){
		    	return strLine;	
		    	}
		      
		    }
		    //Close the input stream
		    in.close();
		    }catch (Exception e){//Catch exception if any
		      System.err.println("Error: " + e.getMessage());
		    }
			return "Voice String not found";
		    }
		   
	
public static void windowsExecute(String cmdParam)	{
	System.out.println("Windows : "+ cmdParam +"\n");
	try{
		Runtime.getRuntime().exec(cmdParam);
	    	}
	        catch (Exception err) {
	            err.printStackTrace();
	          }
}

public static void consoleExecute(String CmdParam){
	Runtime rt = Runtime.getRuntime();
	System.out.println("Console : "+ CmdParam +"\n");
     try {
     Process pr = rt.exec(CmdParam);
     BufferedReader input = new BufferedReader(new InputStreamReader(pr.getInputStream()));
     String line=null;
	     while((line=input.readLine()) != null) {
	         System.out.println(line);
	     }

     } catch(Exception e) {
    	 System.out.println(e.toString());
    	 e.printStackTrace();
     }
}

public static void voiceToExecute(String cmdParam) {

	String fullParam = execParam(cmdParam);
	System.out.println("to execute : "+ fullParam);
	fullParam = fullParam.replaceAll("'", "");
	//System.out.println("param new " +  fullParam);
	String[] paramArray = fullParam.split(",");
	// System.out.println("param lengh " +  paramArray.length);
	 if (paramArray.length == 4){
		/*
		 System.out.println("VoiceCommand : "+ paramArray[0]); 
		 System.out.println("Opr System   : "+ paramArray[1]);
		 System.out.println("Interface	  : "+ paramArray[2]);
		 System.out.println("OS Command	  : "+ paramArray[3]);
		*/
		 if(paramArray[2].equals("CLI")) {
			 consoleExecute(paramArray[3]); 
		 } 
		 else if(paramArray[2].equals("GUI")){
			 windowsExecute(paramArray[3]); 
			 
		 } else {
			 System.out.println("Only GUI and CLI are acceptable in command parameter");
		 }
		 
		 
	 } else {
		 System.out.println("Command Found But Not enough Paramater");
	 }
	 
}			
    public static void main(String args[]) {
    	System.out.println("OS detected : "+System.getProperty("os.name").toLowerCase());
    	//voiceToExecute("list file");
    	voiceToExecute("run calculator");
    	//voiceToExecute("list file");
    	System.out.println("ok ...............dah jalan");
    }
}